/*
 * C
 *
 * Copyright 2012-2014 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/* Includes ------------------------------------------------------------------*/

#include <stdio.h>
#include <RTL.h>
#include "microjvm_main.h"
#include "sram_driver.h"

/* Defines -------------------------------------------------------------------*/

#define MICROJVM_STACK_SIZE 2048

/* Globals -------------------------------------------------------------------*/

static U64 javaTaskStack[(MICROJVM_STACK_SIZE)/8];

/* Private functions ---------------------------------------------------------*/

__task void javaTask (void)
{
	microjvm_main();
	os_tsk_delete_self();
}

/* Public functions ----------------------------------------------------------*/

/*
 * Generic main function
 */
int main(void)
{
	printf("START\n");

	SRAM_initialize();

	// start the main task
	os_sys_init_user(javaTask, 10, &javaTaskStack, sizeof(javaTaskStack));
	
	printf("END\n");
}

