/*
 * C
 *
 * Copyright 2012-2014 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/* Includes ------------------------------------------------------------------*/

#include "cpu.h"
#if MCU == 2
#include "stm32f2xx.h"
#include "stm322xg_eval_fsmc_sram.h"
#elif MCU == 4
#include "stm32f4xx.h"
#include "stm324xg_eval_fsmc_sram.h"
#else
#error Invalid MCU
#endif
#include "sram_driver.h"

/* Public functions ----------------------------------------------------------*/

void SRAM_initialize(void)
{
  /* Configure FSMC Bank 1 NOR/SRAM2  */
  SRAM_Init();

  // Configure FSMC Bank 3
  GPIO_InitTypeDef GPIO_InitStructure;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL;
  GPIO_PinAFConfig(GPIOG, GPIO_PinSource10 , GPIO_AF_FSMC);
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
  GPIO_Init(GPIOG, &GPIO_InitStructure);
}
